﻿DECLARE @@sql varchar(max),
		@@DELIVERY_NO varchar(max) = @0,
		@@DOCK_CD varchar(max) = @1,
		@@RCV_PLANT_CD varchar(max) = @2,
		@@SUPPLIER_CD varchar(max) = @3,
		@@SUPPLIER_PLANT varchar(max) = @4

SET @@sql = 'SELECT  MANIFEST_NO, SUPPLIER_NAME, RCV_PLANT_CD, DOCK_CD, SUPPLIER_CD, SUPPLIER_PLANT, ORDER_NO, ROUTE_RATE, SUM(ORDER_PLAN_QTY_LOT) as ORDER_PLAN_QTY_LOT, SUM(RECEIVED) as RECEIVED, SUM(SHORTAGE) as SHORTAGE, [STATUS], REMARK FROM (
SELECT 

a.MANIFEST_NO,
c.SUPPLIER_NAME,
b.RCV_PLANT_CD,
b.DOCK_CD,
b.SUPPLIER_CD,
e.SUPPLIER_PLANT_CD as SUPPLIER_PLANT,
b.ORDER_NO,
SUBSTRING(b.FST_X_DOCK_ROUTE_GRP_CD,1,4) + '' - ''+b.FST_X_DOCK_SEQ_NO as ROUTE_RATE,
--c.ORDER_PLAN_QTY_LOT,
--(
--		SELECT SUM(O) FROM(
--		SELECT 
--			CASE WHEN (SELECT COUNT(bx.RECEIVING_FLG) FROM TB_R_RECEIVING_D bx WHERE bx.ORDER_NO = b.ORDER_NO AND bx.MANIFEST_NO = ax.MANIFEST_NO AND bx.PART_NO = ax.PART_NO AND bx.RECEIVING_FLG = ''0'') > 0 THEN 0 ELSE COUNT(ax.KANBAN_NO) END as O
--		FROM TB_R_DAILY_ORDER_PART ax
--		WHERE 
--		ax.MANIFEST_NO = a.MANIFEST_NO 
--		AND ax.SUPPLIER_PLANT = e.SUPPLIER_PLANT_CD
--		AND ax.DOCK_CD = b.DOCK_CD 
--		AND ax.ORDER_PLAN_QTY_LOT > 0 
--		GROUP BY ax.KANBAN_NO, ax.MANIFEST_NO, ax.PART_NO
--		)tbl
--) as RECEIVED,
--(
--		SELECT SUM(O) FROM(
--		SELECT 
--			CASE WHEN (SELECT COUNT(bx.RECEIVING_FLG) FROM TB_R_RECEIVING_D bx WHERE bx.ORDER_NO = b.ORDER_NO AND bx.MANIFEST_NO = ax.MANIFEST_NO AND bx.PART_NO = ax.PART_NO AND bx.RECEIVING_FLG = ''1'') > 0 THEN 0 ELSE COUNT(ax.KANBAN_NO) END as O
---		FROM TB_R_DAILY_ORDER_PART ax
--		WHERE 
--		ax.MANIFEST_NO = a.MANIFEST_NO 
--		AND ax.SUPPLIER_PLANT = e.SUPPLIER_PLANT_CD
--		AND ax.DOCK_CD = b.DOCK_CD 
--		AND ax.ORDER_PLAN_QTY_LOT > 0 
--		GROUP BY ax.KANBAN_NO, ax.MANIFEST_NO, ax.PART_NO
--		)tbl
--	) as SHORTAGE,
(SELECT COUNT(xx.KANBAN_ID) FROM TB_R_RECEIVING_D xx WHERE xx.MANIFEST_NO = a.MANIFEST_NO AND xx.ORDER_NO = b.ORDER_NO AND xx.PART_NO = c.PART_NO) as ORDER_PLAN_QTY_LOT,
(SELECT COUNT(xx.KANBAN_ID) FROM TB_R_RECEIVING_D xx WHERE xx.MANIFEST_NO = a.MANIFEST_NO AND xx.ORDER_NO = b.ORDER_NO AND xx.PART_NO = c.PART_NO AND xx.RECEIVING_FLG = ''1'') as RECEIVED,
(SELECT COUNT(xx.KANBAN_ID) FROM TB_R_RECEIVING_D xx WHERE xx.MANIFEST_NO = a.MANIFEST_NO AND xx.ORDER_NO = b.ORDER_NO AND xx.PART_NO = c.PART_NO AND xx.RECEIVING_FLG = ''0'') as SHORTAGE,
CASE WHEN GETDATE() >= b.ARRIVAL_PLAN_DT  AND (SELECT COUNT(c.KANBAN_ID) FROM TB_R_RECEIVING_D c WHERE c.MANIFEST_NO = a.MANIFEST_NO AND c.RECEIVING_FLG = 1)=0 THEN ''Delayed'' ELSE CASE WHEN GETDATE() <= b.ARRIVAL_PLAN_DT  AND (SELECT COUNT(c.KANBAN_ID) FROM TB_R_RECEIVING_D c WHERE c.MANIFEST_NO = a.MANIFEST_NO AND c.RECEIVING_FLG = 1)=0 THEN ''Ordered'' ELSE CASE WHEN (SELECT COUNT(c.KANBAN_ID) FROM TB_R_RECEIVING_D c WHERE c.MANIFEST_NO = a.MANIFEST_NO AND c.RECEIVING_FLG = 0)=0 THEN ''Completed'' ELSE ''Shortage'' END END END as [STATUS],
CASE WHEN d.REMARK IS NULL THEN ''NOTHING'' ELSE d.REMARK END as REMARK--,
--(SELECT COUNT(REMARK) FROM TB_R_MANIFEST_REMARK rm WHERE rm.MANIFEST_NO=a.MANIFEST_NO AND rm.ORDER_NO=b.ORDER_NO) as REMARKED
FROM TB_R_DELIVERY_CTL_MANIFEST a
LEFT JOIN TB_R_DAILY_ORDER_MANIFEST b ON b.MANIFEST_NO = a.MANIFEST_NO
LEFT JOIN TB_M_SUPPLIER e on e.SUPPLIER_CODE = b.SUPPLIER_CD
LEFT JOIN TB_R_DAILY_ORDER_PART c ON c.MANIFEST_NO = a.MANIFEST_NO
LEFT JOIN TB_R_MANIFEST_REMARK d ON d.MANIFEST_NO = a.MANIFEST_NO AND d.ORDER_NO = b.ORDER_NO
WHERE 1 = 1 '

	IF(@@DELIVERY_NO <> '')
	BEGIN
		SET @@sql = @@sql + ' AND a.DELIVERY_NO = '''+@@DELIVERY_NO+''''
	END

	IF(@@DOCK_CD <> '')
	BEGIN
		SET @@sql = @@sql + ' AND b.DOCK_CD = '''+@@DOCK_CD+''''
	END

	IF(@@RCV_PLANT_CD <> '')
	BEGIN
		SET @@sql = @@sql + ' AND b.RCV_PLANT_CD = '''+@@RCV_PLANT_CD+''''
	END

	IF(@@SUPPLIER_CD <> '')
	BEGIN
		SET @@sql = @@sql + ' AND b.SUPPLIER_CD = '''+@@SUPPLIER_CD+''''
	END

	IF(@@SUPPLIER_PLANT <> '')
	BEGIN
		SET @@sql = @@sql + ' AND c.SUPPLIER_PLANT = '''+@@SUPPLIER_PLANT+''''
	END
	
SET @@sql = @@sql + ')tbl GROUP BY MANIFEST_NO, SUPPLIER_NAME, SUPPLIER_PLANT, RCV_PLANT_CD, DOCK_CD, SUPPLIER_CD, ORDER_NO, ROUTE_RATE, STATUS, REMARK';

IF(@@DELIVERY_NO <> '' OR @@DOCK_CD <> '' OR @@RCV_PLANT_CD <> '' OR @@SUPPLIER_CD <> '' OR @@SUPPLIER_PLANT <> '')
BEGIN
	exec(@@sql);
END
